//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop
#pragma link "rf25x.lib"
#include "Rf25xTestUnit.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "CSPIN"
#pragma resource "*.dfm"
TRF25xTestForm *RF25xTestForm;

////////////////////////

DWORD   dwCOMSpeed[6] = {9600, 19200, 38400, 57600, 115200, 460800};

////////////////////////

HANDLE          	       hRF25x			= INVALID_HANDLE_VALUE;
DWORD			       dwValue;
DWORD			       dwMeasured;
RF25xHELLOANSWER	       hlans;
HMODULE                        hDLL                     = NULL;

////////////////////////
//---------------------------------------------------------------------------
__fastcall TRF25xTestForm::TRF25xTestForm(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TRF25xTestForm::ConnectButtonClick(TObject *Sender)
{
        DWORD dwCOMSpeed;

          if ( hRF25x == INVALID_HANDLE_VALUE)
          {
              memset(&hlans, 0x00, sizeof(RF25xHELLOANSWER));

              switch(COMSpeedComboBox->ItemIndex)
              {
                case 0:
                 dwCOMSpeed = CBR_9600;
                 break;
                case 1:
                 dwCOMSpeed = CBR_19200;
                 break;
                case 2:
                 dwCOMSpeed = CBR_38400;
                 break;
                case 3:
                 dwCOMSpeed = CBR_57600;
                 break;
                case 4:
                 dwCOMSpeed = CBR_115200;
                 break;
                default:
                 break;
              }

              if (!RF25x_OpenPort(COMNameEdit->Text.c_str(), dwCOMSpeed, &hRF25x))
                return;

              if (RF25x_HelloCmd( hRF25x, 1, &hlans ))
	        {
                        DeviceInfoLabel->Caption = "Device type: " + IntToStr(hlans.bDeviceType);
                        DevModLabel->Caption     = "Device modification: " + IntToStr(hlans.bDeviceModificaton);
                        DevSerialLabel->Caption  = "Device serial: " + IntToStr(hlans.wDeviceSerial);
                        DevMaxDistLabel->Caption = "Device max dist: " + IntToStr(hlans.wDeviceMaxDistance);
                        DevRangeLabel->Caption   = "Device range: " + IntToStr(hlans.wDeviceRange);
                        ConnectButton->Caption = "Disconnect";
                } else {
                        Application->MessageBox("Error: Check your COM settings...","Error",MB_ICONWARNING);
                        ConnectButton->Caption = "Connect";
                        RF25x_ClosePort( hRF25x );
                        hRF25x                  = INVALID_HANDLE_VALUE;
                        return;
                }
          } else {
                RF25x_ClosePort( hRF25x );
                hRF25x                  = INVALID_HANDLE_VALUE;
                ConnectButton->Caption  = "Connect";
          }        
}
//---------------------------------------------------------------------------
void __fastcall TRF25xTestForm::FormDestroy(TObject *Sender)
{
        if ( hRF25x != INVALID_HANDLE_VALUE)
        {
                RF25x_ClosePort( hRF25x );
                hRF25x = INVALID_HANDLE_VALUE;
        }
}
//---------------------------------------------------------------------------

void __fastcall TRF25xTestForm::MeasureButtonClick(TObject *Sender)
{
        AnsiString as;
        DWORD     dwMeasuredVal;

        if ( hRF25x == INVALID_HANDLE_VALUE)
          return;

        if (RF25x_Measure( hRF25x, DevCSpinEdit->Value, &dwMeasuredVal))
        {
                as.sprintf("%.04f mm", dwMeasuredVal/10000.0f);
                MeasureLabel->Caption = as;
        }
}
//---------------------------------------------------------------------------

void __fastcall TRF25xTestForm::LockResultButtonClick(TObject *Sender)
{
        if ( hRF25x == INVALID_HANDLE_VALUE)
          return;

        RF25x_LockResult( hRF25x, DevCSpinEdit->Value );
}
//---------------------------------------------------------------------------


void __fastcall TRF25xTestForm::StartStreamButtonClick(TObject *Sender)
{
        if ( hRF25x == INVALID_HANDLE_VALUE)
          return;

        RF25x_StartStream( hRF25x, DevCSpinEdit->Value );

        MeasureTimer->Enabled = true;
}
//---------------------------------------------------------------------------

void __fastcall TRF25xTestForm::StopStreamButtonClick(TObject *Sender)
{
        if ( hRF25x == INVALID_HANDLE_VALUE)
          return;

        RF25x_StopStream( hRF25x, DevCSpinEdit->Value );

        MeasureTimer->Enabled = false;
}
//---------------------------------------------------------------------------

void __fastcall TRF25xTestForm::MeasureTimerTimer(TObject *Sender)
{
        AnsiString as;
        DWORD     dwMeasuredVal;

        if ( hRF25x == INVALID_HANDLE_VALUE)
          return;

        if (RF25x_GetStreamMeasure( hRF25x, &dwMeasuredVal))
        {
                as.sprintf("%.04f mm", dwMeasuredVal / 10000.0f);
                MeasureLabel->Caption = as;
        }
}
//---------------------------------------------------------------------------

